* All analyses are based on anonymized data
* Variable "npwp" is a randomly generated taxpayer ID
set seed 98765
log using "${dofile}/logs/1_5_Extract_taxpayer_employment.log", replace
di in red "Run 1_5_Extract_taxpayer_employment.do"

****** Toggles ******

*****************************
**** SPT PPh 1721 file ******
*****************************

u "$output/analysis/SPT_1721_annual_clean.dta", clear

drop if flag_mistakes

* Check for outliers
foreach var of varlist num_perm num_temp{
	table tax_yr if `var'>0, contents(n `var' mean `var' p75 `var' p99 `var' max `var' )
}

* Drop incredibly large outliers - must be data entry mistake
_pctile num_perm, p(99.99)
drop if num_perm >= r(r1)
_pctile num_temp, p(99.99)
drop if num_temp >= r(r1)

* Look again
foreach var of varlist num_perm num_temp{
	table tax_yr if `var'>0, contents(n `var' mean `var' p75 `var' p99 `var' max `var' )
}


* Conver Rp values to Billion Rp
foreach var of varlist inc_perm inc_temp inctax_perm{
	replace `var' = `var'/10^9
}

ren tax_yr year

keep npwp year *_perm *_temp
destring npwp, replace
saveold "${output}/analysis/SPT_1721_annual_clean_analysis.dta", replace

clear
log close
