* All analyses are based on anonymized data
* Variable "npwp" is a randomly generated taxpayer ID
set seed 98765
log using "${dofile}/logs/9_Penalties.log", replace
di in red "do 9_Penalties.do"

u "${output}/analysis/MPN_detailed_clean.dta", clear

keep if inrange(tax_yr,2003,2011)
tab tax_type
tab tax_cat

// ppH_interest and ppN_interest are payments for admin penalties + interest on late and underpaid payments
keep if inlist(tax_type,"ppH_interest","ppN_interest") | inlist(tax_cat,"ppH","ppN") 

replace tax_cat =tax_type if !inlist(tax_cat,"ppH","ppN")
collapse (sum) taxpaid, by(tax_cat tax_yr)
replace taxpaid = taxpaid/10^9

reshape wide taxpaid, i(tax_yr) j(tax_cat) string

list

outsheet using "${output}/analysis/csv/penalties_and_interest_payments.csv", comma replace
