* All analyses are based on anonymized data
* Variable "npwp" is a randomly generated taxpayer ID
set seed 98765
log using "${dofile}/logs/0_8_map_npwp_to_industry_codes.log", replace
di in red "Run 0_8_map_npwp_to_industry_codes.do"

*****************
**** Toggles ****
*****************


* KLU from SPT 1721 (2002-2008)
u "${output}/dta_raw/SPT_1721_02to08.dta", clear

keep b1thpj b1klu npwp_e
ren npwp_e npwp
ren b1thpj tax_yr
ren b1klu klu

replace klu= subinstr(klu,"'","",.)
replace npwp= subinstr(npwp,"'","",.)

destring npwp tax_yr klu, replace
replace klu = . if klu==0
keep if !missing(klu)

* Get a unique klu for the taxpayer - the one most often used
keep npwp klu 
gen n = 1
collapse (sum) n, by(npwp klu)
bys npwp: egen maxn = max(n)
keep if maxn==n

keep npwp klu
gen double temprand = runiform()
sort npwp temprand
by npwp: gen ord = _n
keep if ord==1
isid npwp
drop temprand ord

ren klu klu_1721

isid npwp

saveold "${output}/analysis/npwp_klu_mapping.dta", replace

clear
log close
